# Create fixed discount

Use **setPromotionDiscount** to set a fixed promotion discount.

## Request parameters

<table><thead><tr><th width="410.2667236328125">Parameter</th><th>Type / Description</th></tr></thead><tbody><tr><td><code>sessionID</code></td><td><strong>Required (string)</strong><br>Output of the <strong>Login</strong> method.</td></tr><tr><td><code>promotionCode</code></td><td><strong>Required (string)</strong><br>The code corresponding to the promotion that you want to set the discount for.</td></tr><tr><td><code>promotionDiscount</code></td><td><strong>Required (object)</strong></td></tr><tr><td><code>promotionDiscount.Type</code></td><td><p><strong>Required (string)</strong></p><p>Discount type:</p><ul><li>PERCENT, use in combination with <code>Value</code></li><li>FIXED, use in combination with <code>Values</code> and <code>DefaultCurrency</code></li></ul></td></tr><tr><td><code>promotionDiscount.Value/Values</code></td><td><p><strong>Required</strong> <strong>(int / array of objects)</strong></p><ul><li>Value = Int, determines the discount percentage from 0 to 100</li><li>Values = Array of Value objects</li></ul></td></tr><tr><td><code>promotionDiscount.Value/Values.Value</code></td><td><strong>Required (object)</strong></td></tr><tr><td><code>promotionDiscount.Value/Values.Value.Currency</code></td><td><strong>Required (string)</strong><br>Discount currency ISO code (ISO 4217).</td></tr><tr><td><code>promotionDiscount.Value/Values.Value.Amount</code></td><td><strong>Required (int)</strong><br>Discount amount in corresponding currency.</td></tr><tr><td><kbd>promotionDiscount.DefaultCurrency</kbd></td><td><strong>Required (string)</strong><br>Default discount currency ISO code (ISO 4217).</td></tr></tbody></table>

### Request sample

```php
<?php
declare(strict_types=1);

class Configuration
{
    public const MERCHANT_CODE = '';
    public const MERCHANT_KEY = '';
    public const URL = 'http://api.2checkout.com/soap/6.0';
    public const ACTION = 'setPromotionDiscount';
    public const PROMOTION_CODE = "AB3WMME0UA";
    //array or JSON
    public const PAYLOAD = <<<JSON
{
  "Type": "FIXED",
  "DefaultCurrency": "USD",
  "Values": [\
    {\
        "Currency": "USD",\
        "Amount": 10\
    },\
    {\
        "Currency": "EUR",\
        "Amount": 10\
    }\
  ]
}
JSON;
}

class Client
{
    private const LOGIN_METHOD = 'login';
    private $calls = 1;
    private $sessionId;

    private function generateAuth(): array
    {
        $merchantCode = Configuration::MERCHANT_CODE;
        $key = Configuration::MERCHANT_KEY;
        $date = gmdate('Y-m-d H:i:s');
        $string = strlen($merchantCode) . $merchantCode . strlen($date) . $date;
        $hash = hash_hmac('md5', $string, $key);

        return compact('merchantCode', 'date', 'hash');
    }

    public function login(string $url)
    {
        $payload = $this->generateAuth();
        $response = $this->call($url, array_values($payload), self::LOGIN_METHOD);
        $this->sessionId = $response['result'];
    }

    public function call(
        string $url = Configuration::URL,
        $payload = Configuration::PAYLOAD,
        string $action = Configuration::ACTION,
        string $promotionCode = Configuration::PROMOTION_CODE
    ): ?array {
        if (empty($this->sessionId) && $action !== self::LOGIN_METHOD) {
            $this->login($url);
        }
        if(is_string($payload)) {
            $payload = json_decode($payload, true);
        }
        if (!empty($this->sessionId)) {
            $payload = [$this->sessionId, $promotionCode, $payload];
        }
        $payload = array_filter($payload);

        $request = json_encode([\
            'jsonrpc' => '2.0',\
            'method' => $action,\
            'params' => $payload,\
            'id' => $this->calls++,\
        ]);
        $curl = curl_init($url);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($curl, CURLOPT_SSLVERSION, 0);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type: application/json', 'Accept: application/json', 'Cookie: XDEBUG_SESSION=PHPSTORM'));
        curl_setopt($curl, CURLOPT_POSTFIELDS, $request);
        $response = curl_exec($curl);
        if(empty($response)) {
            die('Server unavailable');
        }
        echo $response . '</br>';
        return json_decode($response, true);;
    }
}
$client = new Client();
$result = $client->call();
var_dump($result);
```

## Response parameters

<table><thead><tr><th width="188.39990234375">Parameter</th><th>Type</th></tr></thead><tbody><tr><td><code>promotionDiscount</code></td><td><strong>Object</strong></td></tr></tbody></table>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.2checkout.com/json-rpc-api-reference/json-rpc-api-6.0/api-requests/promotions/create-fixed-discount.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
